//
//   PDFabmk  PDFt@CɂǉvO
//         ver. 1.00 2011/01/28  by K.Miki
//              1.01 2012/10/31 ̓t@CƏo̓t@C̏d`FbNǉAy[Wԍ@\ǉ
//              1.02 3012/12/07 taskcǒɕȂƂŏ~܂oO𒼂B
//                              rY̎wEɂ
//

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.awt.dnd.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.filechooser.*;
import com.itextpdf.text.*;
import com.itextpdf.text.pdf.*;

public class PDFabmk extends JFrame implements ActionListener{
   static final int MAXPAGE=10000;
   
   static JButton btorg, btidx, btdst, btgo;
   static JTextField tforg, tfidx, tfdst;
   static File cpath = new File("");
   static JCheckBox cbshow = new JCheckBox("Nɂ\",true);
   static JProgressBar pbar = new JProgressBar(1, 100);
   static String title=new String(""), subtitle=new String(""), author=new String(""), 
      keywords=new String(""), creator=new String("");
   static int np, pn;
   static boolean ftitle,fsubtitle,fauthor,fkeywords,fcreator;
   static int[] pageNum=new int[MAXPAGE], pageLevel=new int[MAXPAGE];
   static String[] contents=new String[MAXPAGE];

  public static void main(String[] args) {
    PDFabmk frame = new PDFabmk();
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.setBounds(100, 100, 360, 220);
    frame.setTitle("PDF add Bookmark");
    new DropTarget(tforg,new dtAdapter(tforg));
    new DropTarget(tfidx,new dtAdapter(tfidx));
    new DropTarget(tfdst,new dtAdapter(tfdst));
    if (args.length==3) {
       File file=new File(args[0]);
       if (!file.exists()) {
   	  System.out.println("Error: "+args[0]+" ݂͑܂B");
	  System.exit(0);
       }
       file=new File(args[1]);
       if (!file.exists()) {
   	  System.out.println("Error: "+args[1]+" ݂͑܂B");
	  System.exit(1);
       }
       putBMK(args[0],args[1],args[2]);
       System.exit(0);
    } else frame.setVisible(true);
  }

  // Drag & Dropւ̑Ή
  private static class dtAdapter extends DropTargetAdapter {
  	 private JTextField x;
  	 dtAdapter(JTextField i) {
	 	x=i;
  	 }
	 public void drop(DropTargetDropEvent dtde) {
        try {
           Transferable trans = dtde.getTransferable();
           DataFlavor flavors[] = trans.getTransferDataFlavors();
           for (int i = 0; i < flavors.length; ++i)
              if (flavors[i].isFlavorJavaFileListType()) {
				 dtde.acceptDrop(DnDConstants.ACTION_COPY_OR_MOVE);
                 java.util.List list = (java.util.List) trans.getTransferData(flavors[i]);
                 for (int j = 0; j < list.size(); ++j) {
                    cpath=(File)list.get(j);
                    x.setText(cpath.getAbsolutePath());
                 }
              }
        } catch (IOException ioe) {
	       ioe.printStackTrace();
        } catch (UnsupportedFlavorException ufe) {
           ufe.printStackTrace();
        } finally {
           dtde.dropComplete(true);
        }
     }
  }
  
  // ݒWindow̕\
  PDFabmk(){
    getContentPane().setLayout(new GridLayout(6,1));

    Panel p1=new Panel();
    p1.setLayout(new FlowLayout());
    JLabel lab1=new JLabel("PDFt@C");
    lab1.setPreferredSize(new Dimension(100,25));
    p1.add(lab1);
    tforg=new JTextField("", 15);
    p1.add(tforg);
    btorg=new JButton("Q");
    btorg.addActionListener(this);
    btorg.setPreferredSize(new Dimension(60,25));
    p1.add(btorg);
    getContentPane().add(p1);

    Panel p2=new Panel();
    p2.setLayout(new FlowLayout());
    JLabel lab2= new JLabel("t@C");
    lab2.setPreferredSize(new Dimension(100,25));
    p2.add(lab2);
    tfidx=new JTextField("", 15);
    p2.add(tfidx);
    btidx=new JButton("Q");
    btidx.addActionListener(this);
    p2.add(btidx);
    getContentPane().add(p2);

    Panel p3=new Panel();
    p3.setLayout(new FlowLayout());
    JLabel lab3=new JLabel("ۑt@C");
    lab3.setPreferredSize(new Dimension(100,25));
    p3.add(lab3);
    tfdst=new JTextField("", 15);
    p3.add(tfdst);
    btdst=new JButton("Q");
    btdst.addActionListener(this);
    p3.add(btdst);
    getContentPane().add(p3);

    getContentPane().add(cbshow);

    Panel p4=new Panel();
    p4.setLayout(new FlowLayout());
    pbar.setValue(0);
    pbar.setPreferredSize(new Dimension(140,25));
    p4.add(pbar);
    btgo=new JButton("ǉ");
    btgo.addActionListener(this);
    btgo.setPreferredSize(new Dimension(140,25));
    p4.add(btgo);
    getContentPane().add(p4);
	
    Panel p5=new Panel();
    p5.setLayout(new FlowLayout());
    JLabel lab5=new JLabel("   ver. 1.02  by K.Miki 2012/12/07",JLabel.RIGHT);
    p5.add(lab5);
    getContentPane().add(p5);
  }
  
  // `f[^̓ǂݎ
  static void getContents(String line){
     int i,j;

     for (i=j=0;line.charAt(i)>='0' && line.charAt(i)<='9';i++)
	j=j*10+"0123456789".indexOf(line.charAt(i));
     pageNum[np]=j;
     for (j=0;line.charAt(i)==' ' || line.charAt(i)=='\t';i++) j++;
     pageLevel[np]=j-1;
     contents[np++]=line.substring(i);
  }
  
  // f[^̓ǂݍ
  static void readData(String fname){
     String line;

     ftitle=fsubtitle=fauthor=fkeywords=fcreator=false;
     np=0;
     try {
        FileReader in=new FileReader(fname);
        BufferedReader br=new BufferedReader(in);
        while ((line=br.readLine()) != null) 
	   if (line.equals("")) continue;
           else switch (line.charAt(0)) {
		   case 't': ftitle=true;
                             if (line.length()>2) title=line.substring(2);
                             break;
		   case 's': fsubtitle=true;
                             if (line.length()>2) subtitle=line.substring(2);
                             break;
		   case 'a': fauthor=true;
                             if (line.length()>2) author=line.substring(2);
                             break;
		   case 'k': fkeywords=true;
                             if (line.length()>2) keywords=line.substring(2);
                             break;
		   case 'c': fcreator=true;
                             if (line.length()>2) creator=line.substring(2);
                             break;
		   default : if (line.charAt(0)>='1' && line.charAt(0)<='9') getContents(line);
           }
        br.close();
        in.close();
     } catch (IOException e) {
        e.printStackTrace();
     }
  }

  // f[^̃y[Wԍ̏
  static String modContents(String cont){
     int i,len,n;
     String line;

     line="";
     len=cont.length();
     for (i=0;i<len;i++)
        if (cont.charAt(i)=='$')
           if (i<len-1 && cont.charAt(i+1)=='=') { // y[Wԍ̐ݒ $=100
              
              for (pn=0,i+=2;i<len && cont.charAt(i)>='0' && cont.charAt(i)<='9';i++) 
                 pn=pn*10+"0123456789".indexOf(cont.charAt(i));
              i--;
              line=line+Integer.toString(pn);
           } else if (i<len-1 && cont.charAt(i+1)=='$') { // $̂܂܏o
              line=line+"$";
              i++;
            } else { // y[Wԍo
              line=line+Integer.toString(pn);
           }
        else // $ȊO͂̂܂܏o
           line=line+cont.charAt(i);
     return line;
  }
  // ۂ̎dƂ iText̃TvBookmarks_java.htmlQl
  static void putBMK(String orgname, String idxname, String dstname) {
  	 int n,i,j;
	 float width,height;
	 Document document;
	 PdfContentByte pcb;
	 PdfDestination idx;
	 PdfOutline[] level=new PdfOutline[100];

	 pbar.setStringPainted(false);
	 readData(idxname);
     try {
        PdfReader reader = new PdfReader(orgname);
        n=reader.getNumberOfPages();
	Map info=reader.getInfo();
	document=new Document(reader.getPageSize(1));
        PdfWriter writer=PdfWriter.getInstance(document,new FileOutputStream(dstname));
        document.open();
		if (ftitle) document.addTitle(title);
		else        document.addTitle((String)info.get("Title"));
		if (fauthor) document.addAuthor(author);
		else         document.addAuthor((String)info.get("Author"));
		if (fsubtitle) document.addSubject(subtitle);
		else           document.addSubject((String)info.get("Subject"));
		if (fkeywords) document.addKeywords(keywords);
		else           document.addKeywords((String)info.get("Keywords"));
		if (fcreator) document.addCreator(creator);
		else          document.addCreator((String)info.get("Creator"));
		if (cbshow.isSelected())
		   writer.setViewerPreferences(PdfWriter.PageModeUseOutlines); // ̕\
        PdfContentByte cb = writer.getDirectContent();
		pbar.setMaximum(n);pbar.setValue(0);pbar.paintImmediately(pbar.getVisibleRect());
        for (pn=i=1;i<=n;i++,pn++) {
           document.newPage();
           pbar.setValue(i);pbar.paintImmediately(pbar.getVisibleRect());
           PdfImportedPage page=writer.getImportedPage(reader,i);
	   for (j=0;j<np;j++)
              if (pageNum[j]==i) {
                 idx=new PdfDestination(PdfDestination.FITH);
                 if (pageLevel[j]==0) 
		    level[0]=new PdfOutline(cb.getRootOutline(), idx, modContents(contents[j]));
		 else if (level[pageLevel[j]-1]!=null)
		    level[pageLevel[j]]=new PdfOutline(level[pageLevel[j]-1], idx, modContents(contents[j]));
		 else {
		    JOptionPane.showMessageDialog(null,"u"+contents[j]+"v̏̃x̌o܂",
					   "𒆒f܂",JOptionPane.INFORMATION_MESSAGE);
		    pbar.setValue(0);
                    return;
		 }
		 break;
	      }
           cb.addTemplate(page, 1, 0, 0, 1, 0, 0);
        }
        document.close();
	pbar.setStringPainted(true);
        pbar.setString("");
     } catch (Exception de) {
            de.printStackTrace();
     }
  }

  //  {^̃NbNւ̑Ή
  public void actionPerformed(ActionEvent e){
	 JFileChooser fchooser;
	 
     if (e.getSource().equals(btorg)) { /* t@C̎Q */
        if (cpath.getPath().equals("")) fchooser = new JFileChooser();
		else                            fchooser = new JFileChooser(cpath);
        javax.swing.filechooser.FileFilter filter1=new FileNameExtensionFilter("PDF document (*.pdf)","pdf");
        fchooser.addChoosableFileFilter(filter1);
        if (fchooser.showOpenDialog(this)==JFileChooser.APPROVE_OPTION){
		   cpath=fchooser.getCurrentDirectory();
           tforg.setText(fchooser.getSelectedFile().getPath());
        }
    } else if (e.getSource().equals(btidx)) { /* t@C̎Q */
        if (cpath.getPath().equals("")) fchooser = new JFileChooser();
		else                            fchooser = new JFileChooser(cpath);
        javax.swing.filechooser.FileFilter filter1=new FileNameExtensionFilter("Text document (*.txt)","txt");
        fchooser.addChoosableFileFilter(filter1);
        if (fchooser.showOpenDialog(this)==JFileChooser.APPROVE_OPTION){
		   cpath=fchooser.getCurrentDirectory();
           tfidx.setText(fchooser.getSelectedFile().getPath());
        }
    } else if (e.getSource().equals(btdst)) { /* ۑւ̎Q */
        if (cpath.getPath().equals("")) fchooser = new JFileChooser();
		else                            fchooser = new JFileChooser(cpath);
        javax.swing.filechooser.FileFilter filter1=new FileNameExtensionFilter("PDF document (*.pdf)","pdf");
        fchooser.addChoosableFileFilter(filter1);
        if (fchooser.showSaveDialog(this)==JFileChooser.APPROVE_OPTION){
		   cpath=fchooser.getCurrentDirectory();
           tfdst.setText(fchooser.getSelectedFile().getPath());
        }
    } else if (e.getSource().equals(btgo)) { /* ̊Jn */
	   if (tforg.getText().equals("")) {
	   	  JOptionPane.showMessageDialog(this,"PDFt@Cw肵Ă","ł܂" ,
			 JOptionPane.INFORMATION_MESSAGE);
		  return;
	   }
	   if (tfidx.getText().equals("")) {
	   	  JOptionPane.showMessageDialog(this,"t@Cw肵Ă","ł܂" ,
		     JOptionPane.INFORMATION_MESSAGE);
		  return;
	   }
	   if (tfdst.getText().equals("")) {
	   	  JOptionPane.showMessageDialog(this,"ۑt@Cw肵Ă","ł܂" ,
			 JOptionPane.INFORMATION_MESSAGE);
		  return;
	   }
	   if (tfdst.getText().equals(tforg.getText())) {
	   	  JOptionPane.showMessageDialog(this,"PDFt@Cƕۑt@C͕ʂ̂̂w肵Ă","ł܂" ,
			 JOptionPane.INFORMATION_MESSAGE);
		  return;
	   }
	   File file=new File(tfdst.getText());
	   if (file.exists() && JOptionPane.showConfirmDialog(this,"㏑Ăǂ̂łH",
		     "ۑt@Cɑ݂܂" ,
			 JOptionPane.WARNING_MESSAGE,JOptionPane.YES_NO_OPTION)==JOptionPane.CANCEL_OPTION) return;
	   putBMK(tforg.getText(),tfidx.getText(),tfdst.getText());
    }
  }
  

}
